﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Class MiniBoard  ' max 5x5 => 25 tiles => 5b/tile  
    Public rows As Integer, cols As Integer
    Public b1 As UInt64, b2 As UInt64

    Public Sub New(ByVal rows As Integer, ByVal cols As Integer)
        Me.rows = rows
        Me.cols = cols
        Reset()
    End Sub
    Public Sub New(ByVal board As MiniBoard)
        Me.rows = board.rows
        Me.cols = board.cols
        Me.b1 = board.b1
        Me.b2 = board.b2
    End Sub

    Private Sub Reset()
        b1 = 0 : b2 = 0
        For i As Integer = 0 To rows - 1
            For j As Integer = 0 To cols - 1
                SetTile(CInt((i * cols) + j), CType((i * cols) + j, UInt64))
            Next
        Next
    End Sub

    Public Function GetTile(ByVal index As Integer) As UInt64
        If index > 24 Then Throw New IndexOutOfRangeException("MiniBoard can be indexed only in the range from 0 to 24 (inclusive)!")
        Dim b As UInt64
        If index < 12 Then
            b = b1
        ElseIf index < 24 Then
            index -= 12
            b = b2
        Else    'index == 24    
            index -= 24
            b = ((b1 >> 60) << 4) Or (b2 >> 60)
        End If
        Dim ret As UInt64 = ((b >> (index * 5)) And 31)
        Return ret
    End Function
    Public Sub SetTile(ByVal index As Integer, ByVal value As UInt64)
        If index > 24 Then Throw New IndexOutOfRangeException("MiniBoard can be indexed only in the range from 0 to 24 (inclusive)!")
        Dim mask As UInt64 = 31
        If index < 12 Then
            b1 = (b1 And (Not (mask << (index * 5)))) Or (value << (index * 5))
        ElseIf index < 24 Then
            index -= 12
            b2 = (b2 And (Not (mask << (index * 5)))) Or (value << (index * 5))
        Else    'index == 24   
            mask = Not (mask << 60)
            b1 = b1 And mask
            b2 = b2 And mask
            b1 = b1 Or ((value >> 4) << 60)
            b2 = b2 Or (value << 60)
        End If
    End Sub
End Class